/*	
 *	framdobj.c
 *
 *	RAMɓ]郂W[
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2002 Naoyuki Sawa
 *
 *	* Tue Nov 19 12:30:00 JST 2002 Naoyuki Sawa
 *	- clipdobj.cclipmod.cARs[ECĐVK쐬܂B
 *	* Sun Dec 8 05:43:00 JST 2002 Naoyuki Sawa
 *	- mod_mix()̃[voOCB
 *	- e|GtFNgΉB
 *	* Fri Jan 31 21:57:00 JST 2003 Naoyuki Sawa
 *	- new_LCDDrawObject()PIXEL(p,m)}Nmask蕔ǁB
 *	 u(mask >> (m) & 1)vu(mask & (1 << (m)))vɕύX܂B
 *	  3%(Sʓ])AR[hTCY20oCgȂȂ܂B
 *	  ̉ǂ́uryuǩOH[v(http://www.interq.or.jp/earth/ryuk/)ɂ̂łB
 *	- new_LCDDrawObject()̃NbsOʊO菈ǁB
 *	  ܂ŁA]Ȃ/肻ꂼ̏̒ōsĂ̂AʉĂ܂Ƃ߂܂B
 *	  R[hTCY4oCgȂȂ܂B
 *	- ȏ̕ύXsʁA_̃R[hTCY0xfe0(4064)oCgłB
 *	* Sat Feb 1 14:08:00 JST 2003 Naoyuki Sawa
 *	- new_LCDDrawObject()ɂāAc胉C̎擾uy = obj.dhvʉAeʐߖ񂵂܂B
 *	- MODhCoσ`lɑΉ܂B
 *	* Tue Apr 1 19:00:00 JST 2003 Naoyuki Sawa
 *	- clipfram.c𕪊Ãt@CV݂܂B
 */
#include "clip.h"

/****************************************************************************
 *	pceLCDDrawObject
 ****************************************************************************/

/* * pceLCDDrawObjectɂ́Â悤Ȑ܂B
 * - ]@DRW_NOMALAA]rbg}bv2bitf[^masktłꍇȊÓA
 *   {pceLCDDrawObjectɏC܂BĂяo镪AxȂ܂B
 * - ]`ɁA]rbg}bv͂ݏöw肷ƁA삵܂B
 * - ]rbg}bv́A8sNZPʂ̃TCYō쐬ĂȂ΂܂B
 *   ̐́AP/ECErbg}bv`̐ł̂ŁAɒӂKv͂܂B
 * * AvP[VNɈxhook_LCDDrawObject()ĂсA
 *   AvP[VIɂ͕Kunhook_LCDDrawObject()ǂłB
 */

extern int (*old_LCDDrawObject)(DRAW_OBJECT);	/* {pceLCDDrawObjectۑ -> clippce.c */

int
new_LCDDrawObject(DRAW_OBJECT obj)
{
	PIECE_VRAM dest;
	PIECE_BMP src;
	int n, x, y, step, dest_stride, src_stride;
	unsigned char *dest_buf, *src_mask, mask;
	unsigned short *src_buf, pixel;

	/* ]rbg}bvoĂ܂B
	 * 2bitf[^܂2bitf[^masktłȂ΁A{ɔC܂B
	 */
	src = *obj.src;
	if(src.header.bpp == 2) {
		/* ]VRAM擾B */
		if(obj.dest != NULL) {
			dest = *obj.dest;
		} else {
			dest.w = DISP_X;
			dest.h = DISP_Y;
			dest.buf = pceLCDSetBuffer(INVALIDPTR);
		}

		/* ]NbsOB */
		if(!(obj.param & DRW_REVX)) {
			if(obj.dx < obj.clip.left) {
				n = obj.clip.left - obj.dx; /* ɂ͂ݏosNZ */
				obj.dx = obj.clip.left;
				obj.dw -= n;
				obj.sx += n;
			}
			if(obj.dx + obj.dw > obj.clip.right) {
				obj.dw = obj.clip.right - obj.dx;
			}
		} else {
			if(obj.dx < obj.clip.left) {
				n = obj.clip.left - obj.dx; /* ɂ͂ݏosNZ */
				obj.dx = obj.clip.left;
				obj.dw -= n;
			}
			if(obj.dx + obj.dw > obj.clip.right) {
				n = obj.dx + obj.dw - obj.clip.right; /* Eɂ͂ݏosNZ */
				obj.dw -= n;
				obj.sx += n;
			}
		}
		if(obj.dw <= 0) return 0; /* ʊO */
		if(!(obj.param & DRW_REVY)) {
			if(obj.dy < obj.clip.top) {
				n = obj.clip.top - obj.dy; /* ɂ͂ݏosNZ */
				obj.dy = obj.clip.top;
				obj.dh -= n;
				obj.sy += n;
			}
			if(obj.dy + obj.dh > obj.clip.bottom) {
				obj.dh = obj.clip.bottom - obj.dy;
			}
		} else {
			if(obj.dy < obj.clip.top) {
				n = obj.clip.top - obj.dy; /* ɂ͂ݏosNZ */
				obj.dy = obj.clip.top;
				obj.dh -= n;
			}
			if(obj.dy + obj.dh > obj.clip.bottom) {
				n = obj.dy + obj.dh - obj.clip.bottom; /* ɂ͂ݏosNZ */
				obj.dh -= n;
				obj.sy += n;
			}
		}
		if(obj.dh <= 0) return 0; /* ʊO */

		/* ]NbsO͍s܂B
		 * Xw肳ꂽ]`]rbg}bvɎ܂ĂȂ΁A
		 * ]NbsOɂē]͂ݏoƂ͂肦ȂłB
		 * {͓]NbsOsĂ̂ŁA̓_͔݊łB
		 */

		/* ]sNZAhX߂܂B */
		n = (src.header.w * obj.sy + obj.sx) / 8;
		src_buf = (unsigned short*)src.buf + n;
		src_mask = src.mask + n;
		src_stride = src.header.w / 8 - ((obj.sx & 7) + obj.dw - 1) / 8;
		/*                                                     ~~~      */
		/* 8Xebvɐiނ̂ł͂ȂA9Xebvڂ̐擪Őiނ */

		/* c]CpӂĂ܂B */
		y = obj.dh;

		/* ]ɂāA𕪂܂B(DRW_NOMAL=0Ɖ)
		 * ]ȊÕtOw肳ĂA{ɔC܂B
		 */
		switch(obj.param) {
		case 0/*]Ȃ*/:
			/* ]sNZAhX߂܂B */
			dest_buf = dest.buf + dest.w * obj.dy + obj.dx;
			dest_stride = dest.w - obj.dw;

			switch(src.header.mask) {
			case 0/*2bitf[^*/:
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_01: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
#define PIXEL(p) \
						/* sNZA`܂B */ \
						*dest_buf++ = pixel >> (p) * 2 & 3; \
						/* 1C]A܂B */ \
						if(--x == 0) break;
					case 0: PIXEL(3);
					case 1: PIXEL(2);
					case 2: PIXEL(1);
					case 3: PIXEL(0);
					case 4: PIXEL(7);
					case 5: PIXEL(6);
					case 6: PIXEL(5);
					default/*7*/: PIXEL(4); goto LOOP_01;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf += dest_stride;
					src_buf += src_stride;
				} while(--y != 0);
				return 1; /* `抮 */

			case 1/*2bitf[^maskt*/:
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */
					mask = *src_mask;	/* sNZт MSB:01234567:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_02: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
						mask = *++src_mask;
#define PIXEL(p, m) \
						/* ssNZȂA`܂B */ \
						if(mask & (1 << (m))) *dest_buf = pixel >> (p) * 2 & 3; \
						dest_buf++; \
						/* 1C]A܂B */ \
						if(--x == 0) break;
					case 0: PIXEL(3, 7);
					case 1: PIXEL(2, 6);
					case 2: PIXEL(1, 5);
					case 3: PIXEL(0, 4);
					case 4: PIXEL(7, 3);
					case 5: PIXEL(6, 2);
					case 6: PIXEL(5, 1);
					default/*7*/: PIXEL(4, 0); goto LOOP_02;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf += dest_stride;
					src_buf += src_stride;
					src_mask += src_stride;
				} while(--y != 0);
				return 1; /* `抮 */
			}
			break; /* {ɔC܂ */

		case DRW_REVX:
			/* ]sNZAhX߂܂B */
			dest_buf = dest.buf + dest.w * obj.dy + obj.dx + obj.dw - 1;
			dest_stride = dest.w + obj.dw;

			switch(src.header.mask) {
			case 0/*2bitf[^*/:
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_11: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
#define PIXEL(p) \
						/* sNZA`܂B */ \
						*dest_buf-- = pixel >> (p) * 2 & 3; \
						/* 1C]A܂B */ \
						if(--x == 0) break;
					case 0: PIXEL(3);
					case 1: PIXEL(2);
					case 2: PIXEL(1);
					case 3: PIXEL(0);
					case 4: PIXEL(7);
					case 5: PIXEL(6);
					case 6: PIXEL(5);
					default/*7*/: PIXEL(4); goto LOOP_11;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf += dest_stride;
					src_buf += src_stride;
				} while(--y != 0);
				return 1; /* `抮 */

			case 1/*2bitf[^maskt*/:
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */
					mask = *src_mask;	/* sNZт MSB:01234567:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_12: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
						mask = *++src_mask;
#define PIXEL(p, m) \
						/* ssNZȂA`܂B */ \
						if(mask & (1 << (m))) *dest_buf = pixel >> (p) * 2 & 3; \
						dest_buf--; \
						/* 1C]A܂B */ \
						if(--x == 0) break;
					case 0: PIXEL(3, 7);
					case 1: PIXEL(2, 6);
					case 2: PIXEL(1, 5);
					case 3: PIXEL(0, 4);
					case 4: PIXEL(7, 3);
					case 5: PIXEL(6, 2);
					case 6: PIXEL(5, 1);
					default/*7*/: PIXEL(4, 0); goto LOOP_12;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf += dest_stride;
					src_buf += src_stride;
					src_mask += src_stride;
				} while(--y != 0);
				return 1; /* `抮 */
			}
			break; /* {ɔC܂ */

		case DRW_REVY:
			/* ]sNZAhX߂܂B */
			dest_buf = dest.buf + dest.w * (obj.dy + obj.dh - 1) + obj.dx;
			dest_stride = -dest.w - obj.dw;

			switch(src.header.mask) {
			case 0/*2bitf[^*/:
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_21: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
#define PIXEL(p) \
						/* sNZA`܂B */ \
						*dest_buf++ = pixel >> (p) * 2 & 3; \
						/* 1C]A܂B */ \
						if(--x == 0) break;
					case 0: PIXEL(3);
					case 1: PIXEL(2);
					case 2: PIXEL(1);
					case 3: PIXEL(0);
					case 4: PIXEL(7);
					case 5: PIXEL(6);
					case 6: PIXEL(5);
					default/*7*/: PIXEL(4); goto LOOP_21;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf += dest_stride;
					src_buf += src_stride;
				} while(--y != 0);
				return 1; /* `抮 */

			case 1/*2bitf[^maskt*/:
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */
					mask = *src_mask;	/* sNZт MSB:01234567:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_22: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
						mask = *++src_mask;
#define PIXEL(p, m) \
						/* ssNZȂA`܂B */ \
						if(mask & (1 << (m))) *dest_buf = pixel >> (p) * 2 & 3; \
						dest_buf++; \
						/* 1C]A܂B */ \
						if(--x == 0) break;
					case 0: PIXEL(3, 7);
					case 1: PIXEL(2, 6);
					case 2: PIXEL(1, 5);
					case 3: PIXEL(0, 4);
					case 4: PIXEL(7, 3);
					case 5: PIXEL(6, 2);
					case 6: PIXEL(5, 1);
					default/*7*/: PIXEL(4, 0); goto LOOP_22;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf += dest_stride;
					src_buf += src_stride;
					src_mask += src_stride;
				} while(--y != 0);
				return 1; /* `抮 */
			}
			break; /* {ɔC܂ */

		case DRW_REVX | DRW_REVY:
			/* ]sNZAhX߂܂B */
			dest_buf = dest.buf + dest.w * (obj.dy + obj.dh - 1) + obj.dx + obj.dw - 1;
			dest_stride = -dest.w + obj.dw;

			switch(src.header.mask) {
			case 0/*2bitf[^*/:
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_31: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
#define PIXEL(p) \
						/* sNZA`܂B */ \
						*dest_buf-- = pixel >> (p) * 2 & 3; \
						/* 1C]A܂B */ \
						if(--x == 0) break;
					case 0: PIXEL(3);
					case 1: PIXEL(2);
					case 2: PIXEL(1);
					case 3: PIXEL(0);
					case 4: PIXEL(7);
					case 5: PIXEL(6);
					case 6: PIXEL(5);
					default/*7*/: PIXEL(4); goto LOOP_31;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf += dest_stride;
					src_buf += src_stride;
				} while(--y != 0);
				return 1; /* `抮 */

			case 1/*2bitf[^maskt*/:
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */
					mask = *src_mask;	/* sNZт MSB:01234567:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_32: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
						mask = *++src_mask;
#define PIXEL(p, m) \
						/* ssNZȂA`܂B */ \
						if(mask & (1 << (m))) *dest_buf = pixel >> (p) * 2 & 3; \
						dest_buf--; \
						/* 1C]A܂B */ \
						if(--x == 0) break;
					case 0: PIXEL(3, 7);
					case 1: PIXEL(2, 6);
					case 2: PIXEL(1, 5);
					case 3: PIXEL(0, 4);
					case 4: PIXEL(7, 3);
					case 5: PIXEL(6, 2);
					case 6: PIXEL(5, 1);
					default/*7*/: PIXEL(4, 0); goto LOOP_32;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf += dest_stride;
					src_buf += src_stride;
					src_mask += src_stride;
				} while(--y != 0);
				return 1; /* `抮 */
			}
			break; /* {ɔC܂ */
		}
	}

	/* [`ΉĂȂ`ȂA{ɔC܂B */
	return old_LCDDrawObject(obj);
}

